                          esl syntax         first version 27.01.2005
                          **********         last revision 29.01.2005     

Although esl semantics is scheme semantics, esl syntax is quit different.
The esl syntax is more standard.

esl syntax is converted to scheme syntax by esl and then evaluated as scheme
syntax.

Try
parseon();
This enables the output of the parsed esl input before evaluation. 
Note that esl symbols are prepended with a dollar sign. Do not enter this
dollar sign when working in esl.
parseoff();
turns off this feature.

An important feature of esl syntax, when compared to other standard syntax
languages: The comma (,) is not only used as delimiter in lists or similiar
situations (separating arguments in function), but als as delimiter between
statements. The semicolon is not used for this latter purpose. The semicolon
is used to separate parsing units. Everything between two semicolons is
parsed as a unit.Therefore it must be a valid piece of the language.
Never use the semicolon within control constructs.
while [cond] do stat1; stat2 endwhile
will not work, because "while [cond] do stat1" is not a valid parse unit.
Consider the semicolon as an request to esl: "Parse and evaluate the preceding
input".

Every variable must be explicitely defined (or "bound" within a control
construct). Defining a variable involves assigning a value.
Define variable using the :: operator (corresponding to scheme define
or variable binding in scheme control constructs like let):
 
var::[value]

The fundemantal assignment operator is :=

var:=[value]

assigns [value] to var. var must have been "defined" before. := returns an
unspecified value. := is scheme's set!.
You can also use the simple colon
var:[value]
for assignment. : returns the assigned value. You can use something like
a:b:c:0
to assign 0 to the variables a, b, c. Use the colon only in interactive esl. 

1. There are functions, operators, control constructs. See 'help "overview"'.
   There is special syntax for some important situations. See 11. below.

2. Function calls have standard syntax: f(arg1, arg2, ...). There are
   other possibilities for zero and one argument functions. However, standard
   syntax (using parentheses) will always work.

3. Calls for functions without arguments must include the parenthesis:
   parseon()
   or the must emply the new syntax
   !parseon
   (this feature is included in version 0.05, patchlevel 15). Do not use
   this for the definition of zero argument functions.

4. Functions with exactly one argemunt may be called without parentheses:

   sqrt 2          or    sqrt(2).

   When in doubt, use parentheses.

5. There are prefix, postfix and infix operators. Operator precedence is
   controlled by "binding powers". See 'help "operators"'.

6. End-of-line-comments:   everything between *** and End of line (including
   ***) is considered a comment.

7. C-style comments:
   /* [anything but "/*", "*/"] */
   is considered as whitespace. It may contain linebreaks.
   C-style comments may be nested. Something like
   /* ...  /* ... */ ../* ... /* ... */ ...*/ ... */
   is a comment, when /* ... */ only occur in matching pairs.

8. String constants are enclosed in "  ". The usual escape sequences
   \\ \'  \"  \n will work.

9. There is a data type "symbol" (see scheme manual).

10. The single apostroph is an operator. It is not used pairwise.
   animal :: 'dog
   means: A variable animal is defined its value is dog (the symbol dog).
   This is different from
   animal :: dog
   The latter will only work if dog has a value (id "defined"). If this is
   the case, the value of animal will not become dog, but the value of the
   variable dog.

11. Special syntax

   Functions
   ---------
   Functions may be defined with standard syntax using the -> operator
   (corresponding to scheme lambda):

   t->t*t+t,
   or
   (x,y)->sin x * cos y,
   You can define a variable with a function a value using :: combined with
   ->.
   f::t->t*t+t,
   The additional syntax
   f(t)::t*t+t
   is syntactic sugar for the former.
   
   Lists
   -----
   {el1, el2, ...}
   is equivalent to
   list(el1,el2, ...)
   first(op), rest(op) can be located left to an assignment sign. In this
   case, it acts like the scheme syntax set-car!, set-cdr!, respectively.
   
   Arrays
   ------
   a::[l1..u1,l2..u2, ..., ln..un]
   creates an array with n dimensions. Index bounds may be any integers,
   the only condition is that li<=ui always holds.
   array element reference by a[i1,i2,...,in]. This may be on the left
   side of an assignment:
   a[i1,i2, ..., in] := [expression]
   An array element can hold any value.
