linear_algebra_version::"0.03", linear_algebra_date::"04.08.1999";

/* Linear Algebra (much has to be added) */

identitymatrix(n)::      *** Identity Matrix of order n 
if not integerq(n) or n<1 then
  displayln("identitymatrix: invalid argument",n),
  0
else
  with im::[1..n,1..n] do
    for i from 1 to n do 
      for j from 1 to n do
        im[i,j] := 0
      endfor,
      im[i,i] := 1
   endfor,
   im
  endwith
endif;

rotate2dim(angle)::      *** generates 2 dimensional rotation matrix 
if not numberq(angle) then
  displayln("rotate2dim: invalid argument",angle),
  0
else
  with r::[1..2,1..2] do
    r[1,1] := cos(angle),
    r[2,2] := cos(angle),
    r[1,2] := -sin(angle),
    r[2,1] := sin(angle),
    r
  endwith
endif;


numberxmat(s,a)::               *** returns a newly allocated matrix which 
if not matrixq (a) then         *** is the product of the number s and the
                                *** matrix a. 
  displayln("numberxmat: second arguments is not a matrix"),
  a
elseif not numberq(s) then
  displayln("numberxmat: first argument is not a number."),
  a
else
  with
    rl::lowindex(a,1),ru::highindex(a,1),
    cl::lowindex(a,2),cu::highindex(a,2),
    t::[rl..ru,cl..cu]
  do
    for r from rl to ru do
      for c from cl to cu do
        t[r,c] := s*a[r,c]
      endfor
    endfor,
    t
  endwith
endif;

matmul(a,b)::          *** returns a newly allocated matrix which is the
                       *** product of matrices a and b.

if not (matrixq (a) and matrixq(b)) then
  displayln("matmul: at least one of arguments is not a matrix"),
  0
elseif not (highindex(a,2)-lowindex(a,2)) = (highindex(b,1)-lowindex(b,1)) then
  displayln("matmul: matrices are not of compatible types for multiplication"),
  0
else
  with
    rl::lowindex(a,1),ru::highindex(a,1),
    cl::lowindex(b,2),cu::highindex(b,2),
    jl::lowindex(a,2),ju::highindex(a,2),
    ishift::lowindex(b,1)-jl,
    p::[rl..ru,cl..cu]
  do
    for r from rl to ru do
      for c from cl to cu do
        p[r,c] := sum j->a[r,j]*b[j+ishift,c] from jl to ju endsum
      endfor
    endfor,
    p
  endwith
endif;

matadd(a,b)::          *** returns a newly allocated matrix which is the
                       *** sum of matrices a and b.

if not (matrixq (a) and matrixq(b)) then
  displayln("matadd: at least one of arguments is not a matrix"),
  0
elseif not (      lowindex(a,1)  = lowindex(b,1) 
             and  highindex(a,1) = highindex(b,1)
             and  lowindex(a,2)  = lowindex(b,2) 
             and  highindex(a,2) = highindex(b,2)
           )                                                     then

  displayln("matadd: index ranges of matrices are different."),
  0
else
  with
    rl::lowindex(a,1),ru::highindex(a,1),
    cl::lowindex(a,2),cu::highindex(a,2),
    s::[rl..ru,cl..cu]
  do
    for r from rl to ru do
      for c from cl to cu do
        s[r,c] := a[r,c]+b[r,c]
      endfor
    endfor,
    s
  endwith
endif;


addnumberxlinetoline(s,i,j,cstart,a)::  

/*  If cstart is the lowest column index, then adds s times line i to line j
    in matrix a. If cstart is greater, then only the parts of the lines
    i and j that begin with column cstart are processed.
    Does not allocate a new matrix. Returns the empty list.
    Uses the scheme functions vector-ref and vector-set! (in esl called
    vectorref and vectorset, respectively) instead of a[i,k],... and should
    therefore be more efficient.
*/

if not matrixq(a) then
  displayln("addnumberxlinetoline: last argument is not a matrix"),
  {}
elseif   i < lowindex(a,1) 
      or i > highindex(a,1) 
      or j < lowindex(a,1) 
      or j > highindex(a,1)
      or i = j              then
  displayln("addnumberxlinetoline: Indizes (Arguments 2 and 3) are invalid."),
  {}
elseif cstart < lowindex(a,2) or cstart > highindex(a,2) then
  displayln("addnumberxlinetoline: Startindex (Argument 4) is invalid."),
  {}
elseif not numberq(s) then
  displayln("addnumberxlinetoline: s (Argument 1) is not a number."),
  {}
else
  with
    startindexfrom::index1dim(a,i,cstart),
    startindexto  ::index1dim(a,j,cstart)
  do
    for k from 0 to highindex(a,2)-cstart do 
      vectorset(  second(a),
                  startindexto+k,
                  vectorref(second(a),startindexto+k)
                                  +s*vectorref(second(a),startindexfrom+k)
               )
    endfor, 
    {}
  endwith
endif;

lufactor(a)::
if not (      matrixq(a)
         and  lowindex(a,1)=1 and lowindex(a,2)=1
         and  highindex(a,1) = highindex(a,2) )             then

  displayln("lufactor: argument must be a 2 dimensional square matrix",
           "with indizes\n   starting from 1."),
  0
else
  with
    n::highindex(a,1),
    ip::[1..n],
    eps::1.0e-12,tol::0
  do
    for i from 1 to n do
      ip[i] := i,
      for j from 1 to n do tol:=max(tol,abs(a[i,j])) endfor
    endfor,
    if abs(tol)<eps then
      displayln("lufactor: zero matrix or numerically zero matrix"),
      0
    elseif n = 1 then
      ip
    else
      tol : eps*tol,
      iterative_lu(a,n,tol,1,ip)
    endif
  endwith
endif;
 
iterative_lu(a,n,tol,k,ip)::
with
  pivot::0,
  abspivot::0,
  pivotindex::k,
  swap::0,
  elim::0
do
  for i from k to n do
    if abs(a[ip[i],k]) > abspivot then
      abspivot := abs(a[ip[i],k]),
      pivotindex := i 
    endif
  endfor,
  if abspivot < tol then
    displayln("iterative_lu: pivot in column ",k,"could not be found."),
    displayln("The matrix is (numerically) singular."),
    k
  else
    if not pivotindex = k then
      swap := ip[pivotindex], ip[pivotindex] := ip[k], ip[k] := swap
    endif,
    pivot := a[ip[k],k],
    for i from k+1 to n do
      elim := -a[ip[i],k]/pivot,
      addnumberxlinetoline(elim,ip[k],ip[i],k+1,a),
      a[ip[i],k] := elim
    endfor,
    if k = n-1 then
      if abs(a[ip[n],n])<tol then
        displayln("The matrix is (numerically) singular."),
        n
      else
        ip
      endif
    else
      iterative_lu(a,n,tol,k+1,ip)
    endif
  endif
endwith;

lusolve(a,b,ip)::

if not (      matrixq(a)
         and  lowindex(a,1)=1 and lowindex(a,2)=1
         and  highindex(a,1) = highindex(a,2) )             then
  displayln("lusolve: first argument must be a 2 dimensional square matrix",
           "with indizes\n   starting from 1, factorized by lufactor"),
  {}

elseif  not (      arrayq(b) 
               and (    arraydim(b)   = 1 
                     or (     arraydim(b)    = 2 
                          and lowindex(b,2)  = 1
                          and highindex(b,2) = 1)
                   )
               and lowindex(b,1) = 1  )                     then
  displayln("lusolve: second argument must be a one-dim array",
           "or a column with index starting \nfrom 1 or a column"),
  {}

elseif not highindex(b,1) = highindex(a,1)                  then
  displayln("lusolve: order of first argument and length of second argument",
                                              "are different."),
  {}
elseif not (     arrayq(ip)
             and arraydim(ip)    = 1
             and lowindex(ip,1)  = 1
             and highindex(ip,1) = highindex(b,1) )         then
  displayln("lusolve: third argument is not a pivot vector, or has",
                                              "invalid length."),
  {}
else
  with
    n::highindex(b,1),
    x::[1..n],
    s::0,
    adim1::(arraydim(b)=1)
  do
    x[1] := if adim1 then b[ip[1]] else b[ip[1],1] endif,
    if n > 1 then
      for i from 2 to n do
        x[i] := if adim1 then b[ip[i]] else b[ip[i],1] endif
                 + sum j->a[ip[i],j]*x[j] from 1 to i-1 endsum
      endfor
    endif,
    x[n] := x[n]/a[ip[n],n],
    if n > 1 then
      for i from n-1 to 1 by -1 do
        x[i]
          := (x[i] - sum j->a[ip[i],j]*x[j] from i+1 to n endsum) / a[ip[i],i]
      endfor
    endif,
    if adim1 then
      x
    else
      vec2col(x)
    endif
  endwith
endif;

lineqsolve(a,b)::

if not (      matrixq(a)
         and  lowindex(a,1)=1 and lowindex(a,2)=1
         and  highindex(a,1) = highindex(a,2) )             then
  displayln("lineqsolve: first argument must be a 2 dimensional square matrix",
           "with indizes\n   starting from 1."),
  {}

elseif  not (      arrayq(b) 
               and (    arraydim(b)   = 1 
                     or (     arraydim(b)    = 2 
                          and lowindex(b,2)  = 1
                          and highindex(b,2) = 1)
                   )
               and lowindex(b,1) = 1  )                     then
  displayln("lineqsolve: second argument must be a one-dim array",
           "or a column with index starting \nfrom 1 or a column"),
  {}

elseif not highindex(b,1) = highindex(a,1)                  then
  displayln("lineqsolve: order of first argument and length of second argument",
                                              "must be equal."),
  {}
else
  with
    ip::lufactor(a)
  do
    if numberq(ip) then
      displayln("lineqsolve: matrix is invalid or numerically singular."),
      if ip > 0 then displayln("Problem occured in column",ip) endif
    else
     lusolve(a,b,ip)
    endif   
  endwith
endif;

displayln("\nModule \"linear_algebra\" (Version ",linear_algebra_version,", ",
                                                     linear_algebra_date,")");
