begin
display("This is the module \"test_fourier\".\n",
   "Version and date of this test module:"), 
  test_fourier_version::"0.01", 
  test_fourier_date::"20.08.1999",
  displayln(test_fourier_version,"  ",test_fourier_date)
end;
displayln("\nScheme system is ",$scheme_system);
displayln("\n*** Testing procedures in module \"fourier\" ***\n",
          "Version and date of tested module \"fourier\": ",
          fourier_version," ",fourier_date);

displayln(
 "\nComputing Periodic Fourier coefficients of fchain(x)::x/(2*pi) of order",
"0 to 20\non the intervall [-pi, pi], using 40 subintervalls. The n-th sin",
 "coefficient\n(n > 0) should be (-1)^(n+1)/n, all other coefficients should",
 "be zero.\n");
begin
  chaincoef::fouriercoef(x->x/(2*pi),20,40),
  displayln("Order 0 coefficient is",chaincoef[0,1],"\n"),
  for i from 1 to 20 do
    displayln("Order",i,", sin coef:",chaincoef[i,1],", cos coef:",
                                                             chaincoef[i,2])
  endfor
end;

displayln(
 "\nComputing Periodic Fourier coefficients of\n",
  "\"frect(x) :: if x < 0 then -1/4 else 1/4 endif\" of order 0 to 20\n",
"on the intervall [-pi, pi], using 40 subintervalls. The n-th sin coefficient",
 "\n for odd n should be 1/n, all other coefficients should be zero.\n");
begin
  rectcoef::fouriercoef(x->if x<0 then -1/4 else 1/4 endif,20,40),
  displayln("Order 0 coefficient is",rectcoef[0,1],"\n"),
  for i from 1 to 20 do
    displayln("Order",i,", sin coef:",rectcoef[i,1],", cos coef:",
                                                             rectcoef[i,2])
  endfor
end;

displayln(
"\nComputing Periodic Fourier coefficients of\n",
"\"ftri(x) :: (pi-abs(x))/4\" of order 0 to 20 on the intervall [-pi, pi],",
"\nusing 40 subintervalls. The zero order coefficient should be pi*pi/8, the",
"\ncos coefficient for odd n should be 1/n^2, all other coefficients should\n",
"be zero.\n");
begin
  tricoef::fouriercoef(x->(pi-abs(x))/4,20,40),
  displayln("Order 0 coefficient is",tricoef[0,1],"\n"),
  for i from 1 to 20 do
    displayln("Order",i,", sin coef:",tricoef[i,1],", cos coef:",
                                                             tricoef[i,2])
  endfor
end;
 

displayln("\nModule \"fourier\" (Version ",fourier_version,", ",
                                     fourier_date,")");
