begin
display("This is the module \"test_ode\".\n",
   "Version and date of this test module:"), 
  test_ode_version::"0.01", 
  test_ode_date::"17.08.1999",
  displayln(test_ode_version,"  ",test_ode_date)
end;
displayln("\nScheme system is ",$scheme_system);
displayln("\n*** Testing procedures in module \"ode\" ***\n",
          "Version and date of tested module \"ode\": ",
          ode_version," ",ode_date);
displayln(
 "Solving the ode x'(t) = - 2*t*x, initial value x(0)=1, for t from 0 to 1.\n",
 "The exact solution ist x(t) = e^(-x*x), therefore x(1) = 1/e.\n",
 "The statement ",
 "\"second(first(num1ode((t,x)->-2*t*x,0,1,0.005,1.0001)))-1/e\"",
 "\nevaluates to ",
 second(first(num1ode((t,x)->-2*t*x,0,1,0.005,1.0001)))-1/e,
 " (should be about 3e-6)",
 ",\n and \"second(first(rungekutta1((t,x)->-2*t*x,0,1,0.005,1.0001)))-1/e\"",
 "\nevaluates to ",
 second(first(rungekutta1((t,x)->-2*t*x,0,1,0.005,1.0001)))-1/e,
 " (should be about 1e-11)");
displayln(
 "Direct solution at t = 1 of the above problem, using ode1o1n, step 0.005,\n",
 "yields ",ode1o1n((t,x)->-2*t*x,0,1,0.005,1)-1/e," (should be about 1e-11)");
displayln(
 "Now solving the system x'(t) = y(t), y'(t) = - x(t), ",
 "initial values x(0)=0,\ny(0)=1, for t from 0 to pi. ",
 "The exact solution ist x(t) = sin(t), y(t) = cos(t),\n",
 "therefore x(pi) = 0, y(pi) = -1 .\n",
 "The statement ",
 "\"first(num2ode((t,x,y)->y,(t,x,y)->-x,0,0,1,pi/1000,pi+0.0001))\"",
 "\nevaluates to ",
 first(num2ode((t,x,y)->y,(t,x,y)->-x,0,0,1,pi/1000,pi+0.0001)),
 ",\n",
  "and \"first(rungekutta2((t,x,y)->y,(t,x,y)->-x,0,0,1,pi/1000,pi+0.0001))\"",
 "\nevaluates to ",
 first(rungekutta2((t,x,y)->y,(t,x,y)->-x,0,0,1,pi/1000,pi+0.0001)) );
displayln(
 "Direct solution at t = pi of the above system, using ode2o1n, ",
 "step pi/1000,\n",
 "yields ",ode2o1n((t,x,y)->y,(t,x,y)->-x,0,0,1,pi/1000,pi) );
displayln(
 "Direct solution at t = pi/2 of the second order equation x''(t) = -x(t),\n",
 "initial values x(0) = 0, x'(0) = 1, exact solution x(t) = sin(t),\n",
 "x(pi/2) = 1, using ode1o2n, step pi/500, yields ",
 ode1o2n((t,x,dx)->-x,0,0,1,pi/500,pi/2) );

displayln(
"Solution of the second order equation x''(t) = -x(t)-x'(t), initial values\n",
"x(0) = 0, x'(0) = 1, using ode1o2n. This describes a damped oscillation.\n",
"The exact solution is \"dampedos(t)::(2/sqrt(3))*e^(-t/2)*sin(sqrt(3)*t/2)\"",
"\nThe following table contains some values (step is 0.01), the order in \n",
"each line is t, dampedos(t), value obtained by ode1o2n, difference.\n\n");
dampedos(t)::(2/sqrt(3))*e^(-t/2)*sin(sqrt(3)*t/2),h::0;
for fin from 0.1 to 1 by 0.1 do
  h:ode1o2n((t,x,dx)->-x-dx,0,0,1,0.01,fin),
  displayln("t="," ",fin," ",dampedos(fin)," ",h," ",dampedos(fin)-h)
endfor;


displayln("\nModule \"test_ode\" (Version ",test_ode_version,", ",
                                     test_ode_date,")");
